/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 1/1/2003
 * Description : implementation of class dialogScansione
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#include "dialog_scansione.h"

#include <QMessageBox>

dialogScansione::dialogScansione(QWidget *parent)
        : QDialog(parent)
{
    
    setupUi(this);
    _scansionColor = Qt::red;
    _scansionOn = false;
    _scansionType = 1;
    _scansionTime = 1;
    _scansionMode = 1;
    scansionSlider->setValue(1);
    scansionSlider->setTickInterval(0);
    scansionSlider->setInvertedAppearance(false);

    groupBox_3->setEnabled(false);
    

    connect( radioButton_manuale, SIGNAL( pressed() ), this, SLOT( setManual() ) );
    connect( radioButton_automatica, SIGNAL( pressed()), this, SLOT( setAuto() ) );
    connect( radioButton_abilita, SIGNAL( pressed() ), this, SLOT( enable() ) );
    connect( radioButton_diabilita, SIGNAL( pressed() ), this, SLOT( disable() ) );
    connect( radioButton_riguadro, SIGNAL( pressed() ), this, SLOT(setModeRect () ) );
    connect( radioButton_colore, SIGNAL( pressed() ), this, SLOT( setModeColor() ) );



    connect( pushButton_color, SIGNAL( pressed() ), this, SLOT( setColor() ) );
    connect( pushButton_annulla, SIGNAL( pressed() ), this, SLOT( annulla() ) );
    connect( pushButton_conferma, SIGNAL( pressed() ), this, SLOT( conferma() ) );
    connect( scansionSlider, SIGNAL( valueChanged(int )),this, SLOT(setTime()));
}

void dialogScansione::scansionInfo(QColor &color,bool &on, int &type, int &time, int &mode)
{
    
    color = scansionColor;
    on = scansionOn; 
    type = scansionType;
    time = scansionTime;
    mode = scansionMode;
}


void dialogScansione::enable()
{
    _scansionOn = true;
}

void dialogScansione::disable()
{
    _scansionOn = false;
}

void dialogScansione::setAuto()
{
    _scansionType = 1; // Auto
    scansionSlider->setEnabled(true);
}
void dialogScansione::setManual()
{
    _scansionType = 2; // Manual
    scansionSlider->setEnabled(false);
}
void dialogScansione::setModeColor()
{
    _scansionMode = 1; //color
}
void dialogScansione::setModeRect()
{
    _scansionMode = 2; // with rect   
}
void dialogScansione::setTime()
{
    
    _scansionTime = scansionSlider->value();    
}
void dialogScansione::setColor()
{
    QColor dum;
    dum = QColorDialog::getColor(Qt::red,this);
    if( dum.isValid())
        _scansionColor = dum;
}

void dialogScansione::conferma()
{
    scansionColor = _scansionColor;
    scansionOn = _scansionOn;
    scansionType = _scansionType;
    scansionTime = _scansionTime;
    scansionMode = _scansionMode;
    hide();
}

void dialogScansione::annulla()
{
    hide();
}
