/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 1/1/2003
 * Description : implementation of class d_c_r
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#ifndef DIALOG_SCANSIONE_H
#define DIALOG_SCANSIONE_H

#include "ui_scansionedialog.h"
#include<QDialog>
#include<QMainWindow>
#include <QColorDialog>

class dialogScansione : public QDialog, private Ui::scansioneDialog
{
    Q_OBJECT

public:
    dialogScansione(QWidget *parent = 0);
    void scansionInfo(QColor &color,bool &on, int &type, int &time, int &mode);
    int type();
private:
    QColor _scansionColor;
    bool _scansionOn;
    int _scansionType;
    int _scansionTime;
    int _scansionMode;
    QColor scansionColor;
    bool scansionOn;
    int scansionType;
    int scansionTime;
    int scansionMode;
public slots:
    virtual void enable();
    virtual void disable();
    virtual void setAuto();
    virtual void setManual();
    virtual void setModeColor();
    virtual void setModeRect();
    virtual void setTime();
    virtual void setColor();
    virtual void conferma();
    virtual void annulla();
protected:

};

#endif //DIALOG_SCANSIONE_H
