/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 1/1/2003
 * Description : implementation of class qualisoftWindow
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef QQUALISOFT_WINDOW_H
#define QQUALISOFT_WINDOW_H

#include "ui_qqualisoft_window.h"
#include "dialog_scansione.h"
#include<QDialog>
#include<QMainWindow>
#include<QTimer>
#include<QKeyEvent>


class d_c_r;

class qualisoftWindow : public QMainWindow, private Ui::MainWindow
{
    Q_OBJECT

public:
    qualisoftWindow(QWidget *parent = 0);
private:
    QString m_title;
    QString m_data_path;
    QString m_resource_path;
    d_c_r *pExercise;
    int scanType;
    bool scanOn;
    QTimer *timer;
    QColor color_form;
    QColor color_button;
    QColor color_buttonText;
    QColor color_label;
    QColor color_labelText;
    QColor scansionColor;
    int scansionGap;
    int scansionMode;
    dialogScansione *scansionDialog;

public Q_SLOTS:
    virtual void premuto1();
    virtual void premuto2();
    virtual void premuto3();
    virtual void premuto4();
    virtual void premuto5();
    virtual void avanti();
    virtual void restart();
    virtual void info();
    virtual void skipEnabled(int current);
    virtual void timeout();
    virtual void scansione();
protected:
    void keyPressEvent( QKeyEvent * );
    void keyReleaseEvent( QKeyEvent * );
    void enableButtons(bool en=true);
};


#endif //QQUALISOFT_WINDOW_H
