/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 30/10/2002
 * Description : Anagrammi implementation
 *
 * Copyright 2002-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "form1.h"
#include "ui_form1.h"
#include <QMessageBox>
#include <QDropEvent>
#include <QDebug>

#include "aboutdlg.h"
#include "qlabeldrag.h"
#include "anagrammi.h"
#include "anagrammi_version.h"


struct privateForm
{
  anagrammi *quiz;
};

Form1::Form1(QWidget *parent)
: QDialog(parent), ui(new Ui::Form1), d(new privateForm)
{
  ui->setupUi(this);
  QString title     = QString(APPL_NAME) + " V. " + QString(APPL_VERSION);

  setWindowTitle(title);
  setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));
  
  connect(ui->RadioButton1, SIGNAL(clicked()), this, SLOT(level1()));
  connect(ui->RadioButton2, SIGNAL(clicked()), this, SLOT(level2()));
  connect(ui->RadioButton3, SIGNAL(clicked()), this, SLOT(level3()));
  connect(ui->RadioButton4, SIGNAL(clicked()), this, SLOT(level4()));
  
  /*connect(ui->LineEdit1, SIGNAL(textEdited(const QString &)), this, SLOT(check_text(const QString &)) );
  connect(ui->LineEdit2, SIGNAL(textEdited(const QString &)), this, SLOT(check_text(const QString &)) );
  connect(ui->LineEdit3, SIGNAL(textEdited(const QString &)), this, SLOT(check_text(const QString &)) );
  connect(ui->LineEdit4, SIGNAL(textEdited(const QString &)), this, SLOT(check_text(const QString &)) );
  */
  connect(ui->m_go_on, SIGNAL(released()), this, SLOT(avanti()) );
  connect(ui->m_reset, SIGNAL(released()), this, SLOT(azzera()) );
  connect(ui->m_info, SIGNAL(released()), this, SLOT(info()) );
  connect(ui->m_exit, SIGNAL(released()), this, SLOT(esci()) );
  
  init();

  ui->LineEdit5->setDragging ( true );
  ui->LineEdit6->setDragging ( true );
  ui->LineEdit7->setDragging ( true );
  ui->LineEdit8->setDragging ( true );

  connect (ui->LineEdit1, SIGNAL(dropReceived ( QLabel *, QLabel * ) ), this, SLOT ( action_drop ( QLabel*,QLabel* ) ) );
  connect (ui->LineEdit2, SIGNAL(dropReceived ( QLabel *, QLabel * ) ), this, SLOT ( action_drop ( QLabel*,QLabel* ) ) );
  connect (ui->LineEdit3, SIGNAL(dropReceived ( QLabel *, QLabel * ) ), this, SLOT ( action_drop ( QLabel*,QLabel* ) ) );
  connect (ui->LineEdit4, SIGNAL(dropReceived(QLabel *, QLabel *)), this, SLOT(action_drop(QLabel*,QLabel*)));
}

Form1::~Form1()
{
  delete ui;
  delete d;
}

void Form1::init()
{
  QString testo[4];
  QString filename = QString(DATA_DIR) + "/lista1.txt";
  
  anagrammi::m_data_path = QString(DATA_DIR);
  d->quiz = new anagrammi(filename);
  if(!d->quiz->errore())
  {
    d->quiz->anagramma(&testo[0]);
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->m_go_on->setEnabled(false);
  }
  else
  {
    ui->LineEdit1->hide();
    ui->LineEdit2->hide();
    ui->LineEdit3->hide();
    ui->LineEdit4->hide();
    ui->LineEdit5->hide();
    ui->LineEdit6->hide();
    ui->LineEdit7->hide();
    ui->LineEdit8->hide();
    ui->LCDNumber1->hide();
    ui->LCDNumber2->hide();
    ui->RadioButton1->hide();
    ui->RadioButton2->hide();
    ui->RadioButton3->hide();
    ui->RadioButton4->hide();
    ui->ButtonGroup1->hide();
    ui->TextLabel1->hide();
    ui->TextLabel2->hide();
    ui->TextLabel3->hide();
    ui->m_go_on->hide();
    ui->m_reset->hide();
    ui->m_info->hide();
    QString title = QString(APPL_NAME)    + " V. " +  
    QString(APPL_VERSION) + " "    + 
    QString(APPL_DATE)    + " "    +
    QString(APPL_TIME);
    
    QMessageBox::critical( 0, title, QString("Non riesco a trovare il file lista1.txt "));
  }
}
/*
void Form1::check_text ( const QString & text )
{
  QLineEdit *s=NULL, *d=NULL;
  ui->m_result->clear();
  if (text.isEmpty())
    return;

  //source
  if (ui->LineEdit5->text() == text)
  {
    s = ui->LineEdit5;
  }
  else if (ui->LineEdit6->text() == text)
  {
    s = ui->LineEdit6;
  }
  else if (ui->LineEdit7->text() == text)
  {
    s = ui->LineEdit7;
  }
  else if (ui->LineEdit8->text() == text)
  {
    s = ui->LineEdit8;
  }
  //dest
  if (ui->LineEdit1->text() == text)
  {
    d = ui->LineEdit1;
  }
  else if (ui->LineEdit2->text() == text)
  {
    d = ui->LineEdit2;
  }
  else if (ui->LineEdit3->text() == text)
  {
    d = ui->LineEdit3;
  }
  else if (ui->LineEdit4->text() == text)
  {
    d = ui->LineEdit4;
  }
  if (s && d)
    action_drop(s,d);
}
*/

void Form1::action_drop(QLabel *a, QLabel *b)
{
  QString quale;
  int pos;
  bool ok;
  
  quale = b->objectName();
  pos= (quale.mid(8,1)).toInt(&ok);
  if(!d->quiz->verify_token(a->text(),pos))
  {
    b->setText(a->text());
    a->setEnabled(false);
    b->setEnabled(false);
    if(!d->quiz->esatto())
    {
      QString smile = QString(RESOURCE_DIR) + "/smile.png";
      ui->m_result->setPixmap(QPixmap(smile));
      ui->LCDNumber1->display(ui->LCDNumber1->intValue()+1);
      ui->m_go_on->setEnabled(true);
    }
    
  }
  else
  {
    // aumenta errati
    QString frown = QString(RESOURCE_DIR) + "/frown.png";
    ui->m_result->setPixmap(QPixmap(frown));
    ui->LCDNumber2->display(ui->LCDNumber2->intValue()+1);
    b->blockSignals(true);
    b->clear();
    b->blockSignals(false);
  }
}

void Form1::avanti()
{
  ui->LineEdit1->blockSignals(true);
  ui->LineEdit2->blockSignals(true);
  ui->LineEdit3->blockSignals(true);
  ui->LineEdit4->blockSignals(true);
  
  QString testo[4];
  ui->LineEdit1->setText("");
  ui->LineEdit2->setText("");
  ui->LineEdit3->setText("");
  ui->LineEdit4->setText("");
  
  ui->LineEdit1->setEnabled(true);
  ui->LineEdit2->setEnabled(true);
  ui->LineEdit3->setEnabled(true);
  ui->LineEdit4->setEnabled(true);
  ui->LineEdit5->setEnabled(true);
  ui->LineEdit6->setEnabled(true);
  ui->LineEdit7->setEnabled(true);
  ui->LineEdit8->setEnabled(true);
  
  d->quiz->anagramma(&testo[0]);
  
  if(d->quiz->level()<3)
  {
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
  }
  else
  {
    ui->LineEdit4->show();
    ui->LineEdit8->show();
    ui->LineEdit8->setText(testo[3]);
  }
  ui->LineEdit5->setText(testo[0]);
  ui->LineEdit6->setText(testo[1]);
  ui->LineEdit7->setText(testo[2]);
  ui->m_go_on->setEnabled(false);
  ui->LineEdit1->blockSignals(false);
  ui->LineEdit2->blockSignals(false);
  ui->LineEdit3->blockSignals(false);
  ui->LineEdit4->blockSignals(false);
  
  ui->m_result->clear();
  
}

void Form1::level1()
{
  QString testo[4];
  
  d->quiz->setLevel(1);
  
  ui->LineEdit1->setText("");
  ui->LineEdit2->setText("");
  ui->LineEdit3->setText("");
  ui->LineEdit4->setText("");
  
  ui->LineEdit1->setEnabled(true);
  ui->LineEdit2->setEnabled(true);
  ui->LineEdit3->setEnabled(true);
  ui->LineEdit4->setEnabled(true);
  ui->LineEdit5->setEnabled(true);
  ui->LineEdit6->setEnabled(true);
  ui->LineEdit7->setEnabled(true);
  ui->LineEdit8->setEnabled(true);
  
  d->quiz->anagramma(&testo[0]);
  
  ui->LineEdit4->hide();
  ui->LineEdit8->hide();
  
  ui->LineEdit5->setText(testo[0]);
  ui->LineEdit6->setText(testo[1]);
  ui->LineEdit7->setText(testo[2]);
  ui->m_go_on->setEnabled(false);
}

void Form1::level2()
{
  QString testo[4];
  
  d->quiz->setLevel(2);
  if(!d->quiz->errore())
  {
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->m_go_on->setEnabled(false);
  }
  else
  {
    QString title = QString(APPL_NAME)    + " V. " +  
    QString(APPL_VERSION) + " "    + 
    QString(APPL_DATE)    + " "    +
    QString(APPL_TIME);
    QMessageBox::critical( 0, title, QString("Non riesco a trovare il file per il secondo livello, parto dal primo "));
    d->quiz->setLevel(1);
    ui->RadioButton2->setChecked(false);
    ui->RadioButton1->setChecked(true);
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->m_go_on->setEnabled(false);
  }
}

void Form1::level3()
{
  QString testo[4];
  
  d->quiz->setLevel(3);
  if(!d->quiz->errore())
  {
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->show();
    ui->LineEdit8->show();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->LineEdit8->setText(testo[3]);
    
    ui->m_go_on->setEnabled(false);
  }
  else
  {
    QString title = QString(APPL_NAME)    + " V. " +  
    QString(APPL_VERSION) + " "    + 
    QString(APPL_DATE)    + " "    +
    QString(APPL_TIME);
    QMessageBox::critical( 0, title, QString("Non riesco a trovare il file per il terzo livello, parto dal primo "));
    ui->RadioButton3->setChecked(false);
    ui->RadioButton1->setChecked(true);
    d->quiz->setLevel(1);
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->m_go_on->setEnabled(false);
  }
  
}

void Form1::level4()
{
  QString testo[4];
  
  d->quiz->setLevel(4);
  if(!d->quiz->errore())
  {
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->show();
    ui->LineEdit8->show();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->LineEdit8->setText(testo[3]);
    
    ui->m_go_on->setEnabled(false);
  }
  else
  {
    QString title = QString(APPL_NAME)    + " V. " +  
    QString(APPL_VERSION) + " "    + 
    QString(APPL_DATE)    + " "    +
    QString(APPL_TIME);
    QMessageBox::critical( 0, title, QString("Non riesco a trovare il file per il quarto livello, parto dal primo "));
    d->quiz->setLevel(1);
    ui->RadioButton4->setChecked(false);
    ui->RadioButton1->setChecked(true);
    ui->LineEdit1->setText("");
    ui->LineEdit2->setText("");
    ui->LineEdit3->setText("");
    ui->LineEdit4->setText("");
    
    ui->LineEdit1->setEnabled(true);
    ui->LineEdit2->setEnabled(true);
    ui->LineEdit3->setEnabled(true);
    ui->LineEdit4->setEnabled(true);
    ui->LineEdit5->setEnabled(true);
    ui->LineEdit6->setEnabled(true);
    ui->LineEdit7->setEnabled(true);
    ui->LineEdit8->setEnabled(true);
    
    d->quiz->anagramma(&testo[0]);
    
    ui->LineEdit4->hide();
    ui->LineEdit8->hide();
    
    ui->LineEdit5->setText(testo[0]);
    ui->LineEdit6->setText(testo[1]);
    ui->LineEdit7->setText(testo[2]);
    ui->m_go_on->setEnabled(false);
  }
}

void Form1::azzera()
{
  ui->LCDNumber2->display(0);
  ui->LCDNumber1->display(0);
  ui->m_result->clear();
  avanti();  
}



void Form1::info()
{
  QString title = QString(APPL_NAME)    + " V. " +  
  QString(APPL_VERSION) + " "    + 
  QString(APPL_DATE)    + " "    +
  QString(APPL_TIME);
  
  QString info = "(c) 2002 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                 "(c) 2009 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi per la sillabazione";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";

  //AboutDialog about(this, title, info, description, icon);
  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

void Form1::esci()
{
  QApplication::exit();
}
