/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 19/1/2010
 * Description : About dialog
 *
 * Copyright 2010      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "aboutdlg.h"
#include <QMessageBox>
#include <QString>
#include <QPixmap>
#include <QImage>

AboutDialog::AboutDialog( QWidget* parent , QString title, QString info, QString description, QString icon, QString bug, QString join, QString help) : QDialog(parent), Ui_AboutDialog()
{
    setupUi(this);
    textBrowserBug->setOpenExternalLinks(true);
    textBrowserHelp->setOpenExternalLinks(true);
    textBrowserJoin->setOpenExternalLinks(true);

    setWindowTitle(title);


    if (icon.size() > 0) {
        QImage img = QImage(icon).scaled(m_icon->size(),Qt::KeepAspectRatio);
        m_icon->setPixmap (QPixmap::fromImage(img));
    }

    if (description.size() > 0)
        m_description->setText(description);
    //m_url->setText(URL);
    //m_authors->setText(Authors);
//     setWindowIcon(QIcon(QPixmap(Icon)));


    if (info.size() > 0) {
        textBrowserInfo->setHtml(info);
    }


    if (bug.size() > 0)
        textBrowserBug->setHtml(bug);

    if (join.size() > 0)
        textBrowserJoin->setHtml(join);

    if (help.size() > 0)
        textBrowserHelp->setHtml(help);

    connect( m_okButton, SIGNAL( pressed() ), this, SLOT( accept() ) );
    connect( m_aboutQTButton, SIGNAL( pressed() ), this, SLOT(infoQT()));

}



void AboutDialog::infoQT()
{
    QMessageBox::aboutQt( this, "Qt Application " );
}

AboutDialog::~AboutDialog()
{
}
