#include "loadlist.h"
#include "exerciseGui.h"
#include "z.h"

#include <QHeaderView>
#include <QLineEdit>
#include <QtDebug>
#include <QMessageBox>
#include <QInputDialog>
#include <QPrinter>
#include <QPrintDialog>
#include <QFontDialog>
#include <QColorDialog>
#include <QColor>
#include <QScrollBar>
#include <QKeyEvent>
#include <QFileDialog>
#include <QFontMetrics>
#include <QDomDocument>
#include <QTextStream>
#include <QDomNode>
#include <QFile>
#include <QDesktopWidget>
#include <QTextBrowser>
#include <QUrl>
#include <QDir>
#include <QSettings>

#include "aboutdlg.h"
#include "qexpik_version.h"

ExerciseGui::ExerciseGui(QWidget *parent): QMainWindow(parent)
{
	QDesktopWidget screen;
	setupUi(this);
	setWindowState(Qt::WindowMaximized);
	//this->setGeometry(screen.screenGeometry( this ));
  QString title = QString(APPL_NAME)    + " V. " + QString(APPL_VERSION);
  setWindowTitle(title);
  setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));
        
	nErrori = 0;
	scanning = SCAN_EXPRESSION;
	done = true;
	loadSetting();
	

        boxError = new DialogAlarm(this);
	
		
        scansionDialog = new dialogScansione(this);
	timer = new QTimer(this);
	timerResult = new QTimer(this);
	
	es = new Exercise();
	

	(tableWidget->horizontalHeader ())->hide();
    (tableWidget->verticalHeader ())->hide();


	labelScore->hide();
	labelError->hide();
	labelNError->hide();
	score->hide();

		
	pushButton0->hide();
	pushButton1->hide();
	pushButton2->hide();
	pushButton3->hide();
	pushButton4->hide();
	pushButton5->hide();
	pushButton6->hide();
	pushButton7->hide();
	pushButton8->hide();
	pushButton9->hide();
	pushButtonDel->hide();
	pushButtonMinus->hide();
	pushButtonOk->hide();
	pushButtonSlash->hide();
	pushButtonVerific->hide();
	pushButtonDot->hide();
	
	actionA_passi->setEnabled(false);
	actionAutomatica->setEnabled(false);
	//actionInfo_Expressions->setEnabled(false);
	//actionInfo_Qt->setEnabled(false);
	//actionManuale->setEnabled(enable);
	actionRisultato_finale->setEnabled(false);
	actionSalva->setEnabled(false);
	actionScansione->setEnabled(false);
	actionStampa->setEnabled(false);
	actionSalva_Impostazioni->setEnabled(true);
	
	
	actionNuova->setShortcuts(QKeySequence::New);
	pushButtonVerific->setShortcut(QKeySequence::Paste);

	tableWidget->hide();
	label->hide();
	label_2->hide();
	textEdit->hide();
	textEdit->setReadOnly(true);

	tableWidget->setMouseTracking(true);

	
	
	connect( tableWidget, SIGNAL( itemDoubleClicked ( QTableWidgetItem *  ) ), this, SLOT( click(QTableWidgetItem *) ));

	connect(pushButtonVerific, SIGNAL(clicked()), this, SLOT( verificResult()));



	connect(pushButton0, SIGNAL(clicked()), this, SLOT( pressed0()));
	connect(pushButton1, SIGNAL(clicked()), this, SLOT( pressed1()));
	connect(pushButton2, SIGNAL(clicked()), this, SLOT( pressed2()));
	connect(pushButton3, SIGNAL(clicked()), this, SLOT( pressed3()));
	connect(pushButton4, SIGNAL(clicked()), this, SLOT( pressed4()));
	connect(pushButton5, SIGNAL(clicked()), this, SLOT( pressed5()));
	connect(pushButton6, SIGNAL(clicked()), this, SLOT( pressed6()));
	connect(pushButton7, SIGNAL(clicked()), this, SLOT( pressed7()));
	connect(pushButton8, SIGNAL(clicked()), this, SLOT( pressed8()));
	connect(pushButton9, SIGNAL(clicked()), this, SLOT( pressed9()));
	connect(pushButtonOk, SIGNAL(clicked()), this, SLOT( pressedOk()));
	connect(pushButtonDel, SIGNAL(clicked()), this, SLOT( pressedDel()));
	connect(pushButtonSlash, SIGNAL(clicked()), this, SLOT( pressedSlash()));
	connect(pushButtonMinus, SIGNAL(clicked()), this, SLOT( pressedMinus()));
	connect(pushButtonDot, SIGNAL(clicked()), this, SLOT( pressedDot()));


	connect(actionNuova, SIGNAL(triggered()), this, SLOT(newExercise()));

	connect(actionEsci, SIGNAL(triggered()), this, SLOT(close()));

	connect(actionStampa, SIGNAL(triggered()), this, SLOT(printSteps()));

	connect(actionCarattere, SIGNAL(triggered()), this, SLOT(changeFont()));

	connect(actionColore_Bottoni, SIGNAL(triggered()), this, SLOT(changeButtonColor()));

	connect(actionColore_sfondo, SIGNAL(triggered()), this, SLOT(changeBackgroundColor()));

	connect(actionColore_testo, SIGNAL(triggered()), this, SLOT(changeTextColor()));

	connect(actionScansione, SIGNAL(triggered()), this, SLOT(scansion()));

	connect(actionAutomatica, SIGNAL(triggered()), this, SLOT(automaticResolution()));

	connect(actionA_passi, SIGNAL(triggered()), this, SLOT(stepResolution()));

	connect(actionCarica, SIGNAL(triggered()), this, SLOT(fileLoad()));
	connect(actionSalva, SIGNAL(triggered()), this, SLOT(fileSave()));
	connect(actionSalva_con_nome, SIGNAL(triggered()), this, SLOT(fileSaveAs()));
	connect(actionRisultato_finale, SIGNAL(triggered()), this, SLOT(finalResult()));
	
	connect(actionSalva_Impostazioni, SIGNAL(triggered()), this, SLOT(settingSave()));
	connect(actionScegli, SIGNAL(triggered()), this, SLOT(loadDefaultExercise()));
	connect(actionInfo_Expressions, SIGNAL(triggered()), this, SLOT(info()));
	connect(actionManuale, SIGNAL(triggered()), this, SLOT(manual()));
	
	connect( timer, SIGNAL(timeout()), SLOT(timeout()) );
	connect( timerResult, SIGNAL(timeout()), SLOT(timeoutResult()) );

	connect(actionAzzera_Punteggio, SIGNAL(triggered()), this, SLOT(resetScore()));

	setTabOrder(pushButtonOk, pushButton1);
	setTabOrder(pushButton1, pushButton2);
	setTabOrder(pushButton2, pushButton3);
	setTabOrder(pushButton3, pushButton4);
	setTabOrder(pushButton4, pushButton5);
	setTabOrder(pushButton5, pushButton6);
	setTabOrder(pushButton6, pushButton7);
	setTabOrder(pushButton7, pushButton8);
	setTabOrder(pushButton8, pushButton9);
	setTabOrder(pushButton9, pushButton0);
	setTabOrder(pushButton0, pushButtonSlash);
	setTabOrder(pushButtonSlash, pushButtonMinus);
	setTabOrder(pushButtonMinus, pushButtonDot);
	setTabOrder(pushButtonDot, pushButtonDel);
	setTabOrder(pushButtonDel, pushButtonOk);

	scanOn = false;
	
	QFont fontScore = score->font();  
	fontScore.setPointSize(20);
	score->setFont(fontScore);
	labelScore->setFont(fontScore);
	labelError->setFont(fontScore);
	labelNError->setFont(fontScore);
	
}

void ExerciseGui::pressed0()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "0");
        //// qDebug()() << "0\n";
}

void ExerciseGui::pressed1()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "1");
	
}

void ExerciseGui::pressed2()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "2");
	
}

void ExerciseGui::pressed3()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "3");
	
}

void ExerciseGui::pressed4()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "4");
	
}

void ExerciseGui::pressed5()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "5");
	
}

void ExerciseGui::pressed6()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "6");
	
}
void ExerciseGui::pressed7()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "7");
	
}
void ExerciseGui::pressed8()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "8");
	
}
void ExerciseGui::pressed9()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "9");
	
}

void ExerciseGui::pressedOk()
{
	QFontMetrics metrics(font);
	
	
	if(resolutionType != FINAL)
	{
		ZString resItem(currentItem->text());
		bool ok1, ok2;
		
		
		Z a = resItem.toZ(ok2);
		Z b = strRes.toZ(ok1);
		
		if( a == b)
		{
			string txt;
			
			pushButtonVerific->setEnabled(false);

			if(current.isNumber(tableWidget->currentColumn()))
			{
				current.replaceNumber(txt, tableWidget->currentColumn(), a);
			}
			else
				current._getExpr(txt, tableWidget->currentColumn(), a);
				
			es->setExpr(txt);
			current.setExpr(txt.c_str());
			textEdit->append(txt.c_str());

			expressionElement.clear();
	
			// Take expression's element
	
			current.getVectorExpr(expressionElement);
	
	
			// rebuild and show new step
	
			for(unsigned int i = 0; i < expressionElement.size() ;i++)
			{ 
				
				(tableWidget->item(0,i))->setText(expressionElement[i].c_str());
				(tableWidget->item(0,i))->setFlags(Qt::ItemIsEnabled);
				tableWidget->setColumnWidth (i, (metrics.width((tableWidget->item(0, i))->text()) + 6));
			}
	
			/* Erase scansion color from selected item */

			int currentColumn = tableWidget->currentColumn();
			QBrush brushBackground(Qt::white, Qt::SolidPattern);
			(tableWidget->item(0, currentColumn))->setBackground(brushBackground);
			
			// remove column at th end
                        for(unsigned int i = tableWidget->columnCount() - 1; i >= expressionElement.size(); tableWidget->removeColumn(i--)) ;
	
			if(scanType == 1)
			{
				timerResult->stop();
				timer->start(scansionGap);
			}
			scanning = SCAN_EXPRESSION;
			tableWidget->setFocus();
			tableWidget->setCurrentCell(0, 0);	
			QBrush brushScansion(scansionColor, Qt::SolidPattern);
			(tableWidget->item(0,0))->setBackground(brushScansion);
			if(es->isDone())
			{
                                //boxError->setText(tr("Complimenti!!!"));
                                //boxError->exec();
                                boxError->open(tr("Complimenti!!!"));
				done = true;
				QString scoreString(score->text());
				int scoreNumeric = scoreString.toInt() + 1;
				scoreString.setNum(scoreNumeric);
				score->setText(scoreString);
				actionStampa->setEnabled(true);
				nErrori = 0;
			}
				
		}
		else
		{
			if(++nErrori < 3)
                                boxError->setText(tr("Risultato errato!!!"));
			else
                                boxError->setText(tr("Il risultato e' ") + strRes);
	
			if(scanOn)
			{
				releaseKeyboard();
				boxError->exec();
				if(scanType == 1)				
					timerResult->start(scansionGap);
				grabKeyboard();
			}
			else
				boxError->exec();
			
				
		}
	}
	else
	{
		Z res;
		string newExpr;
		static QString next;

		while(!es->isDone())
		{
			es->execNextStep(res, newExpr);
			
			next = (QString) newExpr.c_str();
		}
		
		if(next == (tableWidget->item(0, tableWidget->columnCount() - 1))->text())
		{
			
                        boxError->setText(tr("Complimenti!!!"));
			nErrori = 0;
			if(scanType == 1)
			{
				timerResult->stop();
				//timer->start(scansionGap);
				
			}
			scanning = SCAN_EXPRESSION;
			tableWidget->setFocus();

			/* so result cell become not editable */

			(tableWidget->item(0, tableWidget->columnCount() - 1))->setFlags(Qt::ItemIsEnabled);
			done = true;
//			lcdScore->display(lcdScore->intValue() + 1);
			QString scoreString(score->text());
			int scoreNumeric = scoreString.toInt() + 1;
			scoreString.setNum(scoreNumeric);
			score->setText(scoreString);
			
			actionStampa->setEnabled(true);
		}
		else
		{
			if(++nErrori < 3)
                                boxError->setText(tr("Risultato errato!!!"));
			else
                                boxError->setText(tr("Il risultato e' ") + next);
			(tableWidget->item(0, tableWidget->columnCount() - 1))->setText("");
		}
		
		//releaseKeyboard();
		boxError->exec();	
		//grabKeyboard();
	}
}


void ExerciseGui::fileLoad()
{
	QFile file;
	QFileDialog fileDialog;
	
	//fileDialog.refresh();
	fileName = fileDialog.getOpenFileName(this, tr("Open File"), "./", tr("*"));
	
	if(fileName.length() > 0)
	{
		char buff[1024];
		int len;
		QStringList list;
		file.setFileName(fileName);
		if (file.open(QIODevice::ReadOnly | QIODevice::Text))
		{
			int i;
			while((len = file.readLine(buff, sizeof(buff))) > 0)
			{
				if(buff[len - 1] == '\n')
					buff[len - 1] = '\0';
				list.append(buff);
			}
			textEdit->clear();
                        // qDebug()() << list.count();
			for(i = 0; i < list.count() - 1; i++)
			{
				textEdit->append(list[i]);
				
			}
			
			es->setExpr(list[i].toStdString());
		
			current.setExpr((list[i].toStdString()).c_str());
			expressionElement.clear();
			current.getVectorExpr(expressionElement);
			tableWidget->clear();
		
			tableDraw();
	
			labelScore->show();
			score->show();
			label->show();
			label_2->show();
			textEdit->show();
			tableWidget->show();
			pushButtonVerific->show();
			actionA_passi->setEnabled(true);
			actionAutomatica->setEnabled(true);
			actionRisultato_finale->setEnabled(true);
			actionScansione->setEnabled(true);
	
			done = false;
			scanning = SCAN_EXPRESSION;
			nErrori = 0;
			score->setText("0");
			labelNError->setText("0");	
		}
	}
}

void ExerciseGui::loadDefaultExercise()
{
	LoadList a;
	QString exerciseLoaded = a.getElement();
	
	if(exerciseLoaded.length() > 0)
	{
		es->setExpr(exerciseLoaded.toStdString());
		
		current.setExpr((exerciseLoaded.toStdString()).c_str());
		expressionElement.clear();
		current.getVectorExpr(expressionElement);
		tableWidget->clear();
	
		tableDraw();

		labelScore->show();
		score->show();
		textEdit->clear();
		textEdit->append(exerciseLoaded);
		pushButtonVerific->show();
		label->show();
		label_2->show();
		textEdit->show();
		tableWidget->show();
		actionA_passi->setEnabled(true);
		actionAutomatica->setEnabled(true);
		actionRisultato_finale->setEnabled(true);
		actionScansione->setEnabled(true);
		scanning = SCAN_EXPRESSION;
		done = false;
	}
}

void ExerciseGui::fileSave()
{
	QFile file;
	releaseKeyboard();
	
	if(fileName.length() == 0)
		fileSaveAs();
	else
	{
		file.setFileName(fileName);
		if (file.open(QIODevice::WriteOnly | QIODevice::Text | QIODevice::Truncate))
	    {
	    	
	    	QString text = (textEdit->document())->toPlainText();
	    	
	    	file.write((text.toStdString()).c_str(), text.length());
	    	file.close();
	   	}
	   	else
	   	{
                        boxError->setText(tr("Impossibile salvare!! Verifica i permessi del file"));
	   		boxError->exec();
   		}
	}
	grabKeyboard();
}

void ExerciseGui::fileSaveAs()
{
	QFile file;
	
	releaseKeyboard();
	
	fileName = QFileDialog::getSaveFileName(this, tr("Salva il File"),
                            "./",
                            tr("*"));
    file.setFileName(fileName);
    if (file.open(QIODevice::WriteOnly | QIODevice::Text))
    {
    	
    	QString text = (textEdit->document())->toPlainText();
    	
    	file.write((text.toStdString()).c_str(), text.length());
    	file.close();
   	}
   	else
   	{
                boxError->setText(tr("Impossibile salvare!! Verifica i permessi del file"));
	   	boxError->exec();
  	}
   	
   	grabKeyboard();
}



void ExerciseGui::pressedDel()
{
	QString result = (tableWidget->currentItem())->text();

	if(!(result.isEmpty()))
	{
		result.truncate(result.length() - 1);
		(tableWidget->currentItem())->setText(result);
	}
	else	/* select other operation, current will resolv after */
	{
		QFontMetrics metrics(font);
		tableWidget->setColumnWidth((tableWidget->currentItem())->column(), metrics.width(currentOperation) + 6);
		(tableWidget->currentItem())->setText(currentOperation);
		/* Erase scansion color from selected item */

		
		QBrush brushBackground(Qt::white, Qt::SolidPattern);
		(tableWidget->currentItem())->setBackground(brushBackground);
		
		

		if(scanType == 1)
		{
			timerResult->stop();
			timer->start(scansionGap);
		}

		scanning = SCAN_EXPRESSION;
		tableWidget->setFocus();
		tableWidget->setCurrentCell(0, 0);	
		QBrush brushScansion(scansionColor, Qt::SolidPattern);
		(tableWidget->item(0,0))->setBackground(brushScansion);
	}
}

void ExerciseGui::pressedSlash()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "/");
	
}

void ExerciseGui::pressedMinus()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + "-");
	
}

void ExerciseGui::pressedDot()
{
	(tableWidget->currentItem())->setText((tableWidget->currentItem())->text() + ".");
	
}

void ExerciseGui::newExercise()
{
	
	bool ok;
	char *dum1;
        releaseKeyboard();
	
	QPalette lcdpalette;
	
                                          
    QString text = dialogNew.getExpression(ok);
                                          
    dum1 = strdup((text.toStdString()).c_str());
        /*Expression dum(dum1);*/
        //dum.print();


        if(ok /*&&  dum.isValid()*/)
	{
                scanning = SCAN_EXPRESSION;
		resolutionType = STEP;
		es->setExpr(text.toStdString());
		
		current.setExpr((text.toStdString()).c_str());
		expressionElement.clear();
		current.getVectorExpr(expressionElement);
		tableWidget->clear();
	
		tableDraw();

		labelNError->setText("0");
		score->setText("0");
		labelScore->show();
		labelError->show();
		labelNError->show();
		labelExercise->show();
		labelExercise->setText(text);
		score->show();
		textEdit->clear();
		textEdit->append(text);
		pushButtonVerific->show();
		label->show();
		label_2->show();
		textEdit->show();
		tableWidget->show();
		actionA_passi->setEnabled(true);
		actionAutomatica->setEnabled(true);
		actionRisultato_finale->setEnabled(true);
		actionScansione->setEnabled(true);
		actionStampa->setEnabled(false);
		done = false;
		tableWidget->setFocus();
		tableWidget->setCurrentCell(0, 0);
                nErrori = 0;
	}
        grabKeyboard();
}



void ExerciseGui::click(QTableWidgetItem *item)
{
	if(done)
		return;

	if(resolutionType != FINAL)
	{
		bool ok;
		ZString selectedStringNumber(item->text());
		Z selectedNumber = selectedStringNumber.toZ(ok);
		
		
		if(current.isNumber(item->column()) && selectedNumber.isSimple())
		{
						
			releaseKeyboard();
                        boxError->setText(tr("Hai cliccato su un numero. Puoi cliccare solo sulle operazioni"));
			
			
			if(scanOn)
			{
				releaseKeyboard();
				boxError->exec();
				if(scanType == 1)				
					timer->start(scansionGap);
				grabKeyboard();
			}
			else
				boxError->exec();
			grabKeyboard();
		}
		else if(!current.isNumber(item->column()) && (expressionElement[item->column()] != "(" && expressionElement[item->column()] != ")"))
		{
                        // qDebug()() << "prima\n";
			Z result(0,1);
			
			// Added 27/8/2008 to cell color
			
			QBrush brushBackground(Qt::red, Qt::SolidPattern);
			(tableWidget->item(0, tableWidget->currentColumn()))->setBackground(brushBackground);
			
			// End Added 27/8/2008 to cell color
			
			if(!es->execStep(item->column(), result))
			{
				QFontMetrics metrics(font);
				grabKeyboard();
				strRes = ((result.toString()).c_str());
	
				
                                // qDebug()() << "MAX STRING " << (result.getMaxString()).c_str();
				/* store selectioned operation */

				currentOperation = item->text();	

				item->setText("");
				item->setFont(font);
			
				item->setFlags(/*Qt::ItemIsEnabled|*/Qt::ItemIsEditable);
				
				tableWidget->setColumnWidth(item->column(), metrics.width((result.getMaxString()).c_str()/*strRes*/) + 6);
				
				pushButtonVerific->setEnabled(true);
				currentItem = item;
	
				pushButton1->setFocus();
	
				scanning = SCAN_RESULT;
	
				if(scanOn)
				{
					if(scanType == 1)
					{
						timer->stop();
						timerResult->start(scansionGap);
					}
					else if(scanType == 2)
					{
						pushButton1->setFocus();
					}
					
				}
				
			
				
				
			}
			else
			{
				
                                boxError->setText(tr("Fai Attenzione alla priorita' delle operazioni\n"));
	
				if(scanOn)
				{
					releaseKeyboard();
					boxError->exec();
					if(scanType == 1)				
						timer->start(scansionGap);
					grabKeyboard();
				}
				else
					boxError->exec();
			}
			
			
			
			
		}
		else if(!selectedNumber.isSimple()) /* Number needs semplification */
		{
			QFontMetrics metrics(font);
			
			/* store selectioned operation */

			strRes = item->text();
			currentOperation = item->text();	

			item->setText("");
			item->setFlags(Qt::ItemIsEnabled|Qt::ItemIsEditable);
			tableWidget->setColumnWidth(item->column(), metrics.width(strRes) + 6);
			tableWidget->setCurrentCell(0, item->column());
			pushButtonVerific->setEnabled(true);
			currentItem = item;
			tableWidget->setFont(font);
						
			scanning = SCAN_RESULT;
			
			if(scanOn)
			{
				if(scanType == 1)
				{
					timer->stop();
					timerResult->start(scansionGap);
				}
				else if(scanType == 2)
				{
					pushButton1->setFocus();
				}
				
			}
			

		}
		else
		{
			
                        boxError->setText(tr("Errore!! Puoi cliccare solo sulle operazioni"));
			
			if(scanOn)
			{
				releaseKeyboard();
				boxError->exec();
				if(scanType == 1)				
					timer->start(scansionGap);
				grabKeyboard();
			}
			else
				boxError->exec();
			
		}	
	}
	else if(resolutionType == FINAL)
	{
		tableWidget->setColumnWidth(tableWidget->columnCount() - 1, 30);
		
		currentOperation = "R";
		if(item->column() == tableWidget->columnCount())
			item->setText("");
			
		if(tableWidget->currentColumn() == (tableWidget->columnCount() -1))
		{
			scanning = SCAN_RESULT;
			if(scanOn)
			{
				if(scanType == 1)
				{
					
					timer->stop();
					timerResult->start(scansionGap);
				}
				pushButton1->setFocus();
				
				
			}
			else
				pushButtonVerific->setEnabled(true);
		}
		else
		{
                        boxError->setText(tr("Devi selezionare la casella dopo l'uguale ed inserire li' il risultato"));
			
			if(scanOn)
			{
				if(scanType == 1)
					timer->start(scansionGap);
				releaseKeyboard();
			}
			
			boxError->exec();

			if(scanOn)
				grabKeyboard();
			resolutionType = FINAL;
		}
	}
		
}


void ExerciseGui::verificResult()
{
	QFontMetrics metrics(font);
	
	
	if(resolutionType != FINAL)
	{
		ZString resItem(currentItem->text());
		bool ok1, ok2;
		
		
		Z a = resItem.toZ(ok2);
		Z b = strRes.toZ(ok1);
		
		
                //// qDebug()() << "STRRES " << strRes << "\n";
		
                /*if(ok2)
                        // qDebug()() << "A " << (a.toString()).c_str() << "\n";*/
		
		if( a == b)
		{
			string txt;
			QString scoreString(score->text());
			int scoreNumeric = scoreString.toInt() + 1;
			
			scoreString.setNum(scoreNumeric);
			score->setText(scoreString);
			
			pushButtonVerific->setEnabled(false);



			if(current.isNumber(tableWidget->currentColumn()))
			{
				current.replaceNumber(txt, tableWidget->currentColumn(), a);
			}
			else
				current._getExpr(txt, tableWidget->currentColumn(), a);
				
				
                        //// qDebug()() << "NEW EXPR = " << txt.c_str() << "\n";
				
			es->setExpr(txt);
			current.setExpr(txt.c_str());
			textEdit->append(txt.c_str());

			expressionElement.clear();
	
			// Take expression's element
	
			current.getVectorExpr(expressionElement);
	
			current.print();
	

			// rebuild and show new step
	
			for(unsigned int i = 0; i < expressionElement.size(); i++)
			{ 
                                //// qDebug()()  << " I " << i << "\n";
				(tableWidget->item(0,i))->setText(expressionElement[i].c_str());
				(tableWidget->item(0,i))->setFlags(Qt::ItemIsEnabled);
				tableWidget->setColumnWidth (i, (metrics.width((tableWidget->item(0, i))->text()) + 6));
			}
	
			
	
			// remove column at th end
                        for(unsigned int i = tableWidget->columnCount() - 1; i >= expressionElement.size(); tableWidget->removeColumn(i--)) ;
	
	
			/* Necessary to use keyboard */
	
			tableWidget->setFocus();
			tableWidget->setCurrentCell(0, 0);
			scanning = SCAN_EXPRESSION;
			//for(int i = 0; i < expressionElement.size(); tableWidget->resizeColumnToContents(i++));
	
	
			
	
	
			if(es->isDone())
			{
                                boxError->setText(tr("Complimenti!!!"));
				boxError->exec();
//				lcdScore->display(lcdScore->intValue() + 1);
				
				
				done = true;
				actionStampa->setEnabled(true);
				nErrori = 0;
			}
				
			
			
		}
		else
		{
			QString  errorString;
			int errorNumeric = (labelNError->text()).toInt() + 1;
			
			errorString.setNum(errorNumeric);
			labelNError->setText(errorString);
			
			if(++nErrori < 3)
                                boxError->setText(tr("Risultato errato!!!"));
			else
			{
                                boxError->setText(tr("Il Risultato e' ") + strRes);
				nErrori = 0;
			}
			boxError->exec();
			grabKeyboard();
		}
	}
	else
	{
		Z res;
		string newExpr;
		static QString next; // to store the final result

		while(!es->isDone())
		{
			es->execNextStep(res, newExpr);
			
			next = (QString) newExpr.c_str();
		}
		
		
		if(next == (tableWidget->item(0, tableWidget->columnCount() - 1))->text())
		{
                        boxError->setText(tr("Complimenti!!!"));
//			lcdScore->display(lcdScore->intValue() + 1);

			QString scoreString(score->text());
			int scoreNumeric = scoreString.toInt() + 1;
			scoreString.setNum(scoreNumeric);
			score->setText(scoreString);

			pushButtonVerific->setEnabled(false);
			actionStampa->setEnabled(true);
		}
		else
		{	
			if(++nErrori < 3)
                                boxError->setText(tr("Risultato errato!!!"));
			else
                                boxError->setText(tr("Il Risultato e' ") + next);
		}
			

		boxError->exec();
		grabKeyboard();
	}
}

void ExerciseGui::stepResolution()
{
	resolutionType = STEP;
	actionRisultato_finale->setEnabled(false);
	actionAutomatica->setEnabled(false);
	tableWidget->setFocus();
	tableWidget->setCurrentCell(0, 0);
}

void ExerciseGui::automaticResolution()
{
	Z res;
	string newExpr;
	QString next;

	while(!es->isDone())
    {
		es->execNextStep(res, newExpr);
                
        next = (QString) newExpr.c_str();
        textEdit->append(next);
    }

	actionA_passi->setEnabled(false);
	actionRisultato_finale->setEnabled(false);
}

void ExerciseGui::finalResult()
{
	QTableWidgetItem *newItem;
	QFontMetrics metrics(font);
	
	resolutionType = FINAL;	

	actionA_passi->setEnabled(false);
	actionAutomatica->setEnabled(false);

	pushButtonVerific->setEnabled(true);

	tableWidget->setFocus();
	tableWidget->setColumnCount(tableWidget->columnCount() + 2);

		
    newItem = new QTableWidgetItem(" = ");

		
	tableWidget->setItem(0, tableWidget->columnCount() - 2, newItem);
		
    	

	newItem = new QTableWidgetItem("R");

		
	tableWidget->setItem(0, tableWidget->columnCount() - 1, newItem);
	(tableWidget->item(0, tableWidget->columnCount() - 1))->setFlags(Qt::ItemIsEnabled|Qt::ItemIsEditable);
	(tableWidget->item(0, tableWidget->columnCount() - 2))->setFlags(Qt::ItemIsEnabled);
		
	tableWidget->setColumnWidth(tableWidget->columnCount() - 1, (metrics.width((tableWidget->item(0, tableWidget->columnCount() - 1))->text()) + 6));
	tableWidget->setColumnWidth(tableWidget->columnCount() - 2, (metrics.width((tableWidget->item(0, tableWidget->columnCount() - 2))->text()) + 6));
	tableWidget->setCurrentCell(0, tableWidget->columnCount() - 1);
	
}



void ExerciseGui::printSteps()
{
#ifndef QT_NO_PRINTER
    QPrinter printer(QPrinter::HighResolution);
    printer.setFullPage(true);
    QPrintDialog *dlg = new QPrintDialog(&printer, this);
    dlg->setWindowTitle(tr("Print Document"));
    if (dlg->exec() == QDialog::Accepted) {
        textEdit->document()->print(&printer);
    }
    delete dlg;
#endif

}


void ExerciseGui::changeTextColor()
{
	QPalette palette;	

	QColor color = QColorDialog::getColor(Qt::green,   this);
	
	if(color.isValid())
	{
		textColor = color;
		
		palette.setColor(QPalette::WindowText, color);
		setPalette(palette);
		
		//labelScore->setPalette(palette);
		//lcdScore->setPalette(palette);
		palette.setColor(QPalette::ButtonText, color);
		pushButton1->setPalette( palette );
		pushButton2->setPalette( palette );
		pushButton3->setPalette( palette );
		pushButton4->setPalette( palette );
		pushButton5->setPalette( palette );
		pushButton6->setPalette( palette );
		pushButton7->setPalette( palette );
		pushButton8->setPalette( palette );
		pushButton9->setPalette( palette );
		pushButton0->setPalette( palette );
		pushButtonDel->setPalette( palette );
		pushButtonOk->setPalette( palette );
		pushButtonVerific->setPalette( palette );
	
		palette.setColor(QPalette::Text, color);
		tableWidget->setPalette(palette);
		textEdit->setPalette(palette);	
		
		/*palette.setColor(QPalette::Window, backgroundColor);
		setPalette(palette);*/
		
		/*palette.setColor(QPalette::Button, buttonColor);
		pushButton1->setPalette( palette );
		pushButton2->setPalette( palette );
		pushButton3->setPalette( palette );
		pushButton4->setPalette( palette );
		pushButton5->setPalette( palette );
		pushButton6->setPalette( palette );
		pushButton7->setPalette( palette );
		pushButton8->setPalette( palette );
		pushButton9->setPalette( palette );
		pushButton0->setPalette( palette );
		pushButtonDel->setPalette( palette );
		pushButtonOk->setPalette( palette );
		pushButtonVerific->setPalette( palette );
		pushButtonSlash->setPalette( palette );
		pushButtonMinus->setPalette( palette );*/
		
		
		}
	
	
}

void ExerciseGui::changeBackgroundColor()
{
	QPalette palette;
	QColor color = QColorDialog::getColor(Qt::green, this);
	
	if(color.isValid())
	{
		palette.setColor(QPalette::Window, color);
		setPalette(palette);
		backgroundColor = color;
		
		
		palette.setColor(QPalette::WindowText, textColor);
		setPalette(palette);
		
	}
	
}

void ExerciseGui::changeButtonColor()
{
	QPalette palette;
	QColor color = QColorDialog::getColor(Qt::green, this);

	if(color.isValid())
	{
		buttonColor = color;
		palette.setColor(QPalette::Button,color);
		pushButton1->setPalette( palette );
		pushButton2->setPalette( palette );
		pushButton3->setPalette( palette );
		pushButton4->setPalette( palette );
		pushButton5->setPalette( palette );
		pushButton6->setPalette( palette );
		pushButton7->setPalette( palette );
		pushButton8->setPalette( palette );
		pushButton9->setPalette( palette );
		pushButton0->setPalette( palette );
		pushButtonDel->setPalette( palette );
		pushButtonOk->setPalette( palette );
		pushButtonVerific->setPalette( palette );
		pushButtonSlash->setPalette( palette );
		pushButtonMinus->setPalette( palette );
		
		palette.setColor(QPalette::ButtonText, textColor);
		pushButton1->setPalette( palette );
		pushButton2->setPalette( palette );
		pushButton3->setPalette( palette );
		pushButton4->setPalette( palette );
		pushButton5->setPalette( palette );
		pushButton6->setPalette( palette );
		pushButton7->setPalette( palette );
		pushButton8->setPalette( palette );
		pushButton9->setPalette( palette );
		pushButton0->setPalette( palette );
		pushButtonDel->setPalette( palette );
		pushButtonOk->setPalette( palette );
		pushButtonVerific->setPalette( palette );
		
		
		
	}

	
}

void ExerciseGui::changeFont()
{
	bool ok;
 	QFont fontNew = QFontDialog::getFont(
                 &ok, QFont(font.family(), font.pointSize()), this);
	
	if(ok)
	{
		QFontMetrics fontMetrics(font);
		font = fontNew;
		
		
		
		
		for(int row = 0; row < tableWidget->rowCount(); row++)
			for(int column = 0; column < tableWidget->columnCount(); column++)
				(tableWidget->item(row, column))->setFont(font);
				
	
		for(int i = 0; i < tableWidget->columnCount(); i++)
		{
			if(((tableWidget->item(0, i))->text()).at(0) == '-' && ((tableWidget->item(0, i))->text()).length() > 1)
				tableWidget->setColumnWidth (i, fontMetrics.width((tableWidget->item(0, i))->text()) + 6 );
			else
			{
				tableWidget->setColumnWidth (i, fontMetrics.width((tableWidget->item(0, i))->text()) + 6 );
			}
		}
		tableWidget->resizeRowToContents(0);
		



		textEdit->setFont(font);
		pushButton1->setFont( font );
		pushButton2->setFont( font );
		pushButton3->setFont( font );
		pushButton4->setFont( font );
		pushButton5->setFont( font );
		pushButton6->setFont( font );
		pushButton7->setFont( font );
		pushButton8->setFont( font );
		pushButton9->setFont( font );
		pushButton0->setFont( font );
		pushButtonDel->setFont( font );
		pushButtonOk->setFont( font );
		pushButtonVerific->setFont( font );

		pushButton1->adjustSize();
		pushButton2->adjustSize();
		pushButton3->adjustSize();
		pushButton4->adjustSize();
		pushButton5->adjustSize();
		pushButton6->adjustSize();
		pushButton7->adjustSize();
		pushButton8->adjustSize();
		pushButton9->adjustSize();
		pushButton0->adjustSize();
		pushButtonDel->adjustSize();
		pushButtonOk->adjustSize();
		pushButtonVerific->adjustSize();
		pushButtonSlash->adjustSize();
		pushButtonMinus->adjustSize();		

		label->setFont(font);
		label_2->setFont(font);
		
		label->adjustSize();
		label_2->adjustSize();
		
		font.setPointSize(font.pointSize() + 2);
		labelScore->setFont(font);
		labelScore->adjustSize();
		labelError->setFont(font);
		labelError->adjustSize();
		labelNError->setFont(font);
		labelNError->adjustSize();
		labelExercise->setFont(font);
		labelExercise->adjustSize();
		score->setFont(font);
		score->adjustSize();	
		
		
		
		
		
	}
}



void ExerciseGui::tableDraw()
{
	int row = 0;
	Operation oper;
	QTableWidgetItem *newItem;
	
	QFontMetrics fontMetrics(font);

	tableWidget->setRowCount(1);
	sumColumnWidth = 0;
	

	for(unsigned int i = 0; i < expressionElement.size(); i++)
    { 
		
		tableWidget->setColumnCount(i + 1);

        newItem = new QTableWidgetItem("");

		
	    tableWidget->setItem(row, i, newItem);
		(tableWidget->item(row, i))->setFont(font);
    	(tableWidget->item(row, i))->setText(expressionElement[i].c_str());

		

    	(tableWidget->item(row, i))->setFlags(Qt::ItemIsEnabled);
				
    }
	
	
	


	for(int i = 0; i < tableWidget->columnCount(); i++)
	{
		QString dum;
		
		if(((tableWidget->item(0, i))->text()).at(0) == '-' && ((tableWidget->item(0, i))->text()).length() > 1)
		{
			tableWidget->setColumnWidth (i, (fontMetrics.width((tableWidget->item(0, i))->text()) + 6));
			
		}
		else
		tableWidget->setColumnWidth (i, (fontMetrics.width((tableWidget->item(0, i))->text()) + 6));
		
		
		
		
	}
	tableWidget->resizeRowToContents(0);
	
}

void ExerciseGui::timeoutResult()
{
	int i;
	bool trovato;
	
	

	i = 0;
	trovato = false;
	if(scansionMode == 1)
   	{
		if(pushButtonOk->hasFocus())
			pushButton1->setFocus();
		else
			this->focusNextChild();

		
		


    	}
	/*else
	{
	}*/
   
}


void ExerciseGui::timeout()
{
	
	if(scansionMode == 1)
   	{
		int scroll;
		int currentColumn = tableWidget->currentColumn();
		QBrush brushBackground(Qt::white, Qt::SolidPattern);
			(tableWidget->item(0, currentColumn))->setBackground(brushBackground);
		QBrush brushScansion(scansionColor, Qt::SolidPattern);
			(tableWidget->item(0, currentColumn))->setBackground(brushBackground);
		currentColumn++;
        	tableWidget->setCurrentCell(0, (currentColumn = (currentColumn % tableWidget->columnCount())) );
		tableWidget->setCurrentItem(tableWidget->item(0, currentColumn));
		
		
		(tableWidget->item(0, currentColumn))->setBackground(brushScansion);


		if(horizontalBar->isVisible() &&(tableWidget->columnCount() > horizontalBar->maximum()))
		{
			scroll = (int) (tableWidget->columnCount() / horizontalBar->maximum() );
	
			horizontalBar->setSliderPosition((int) (currentColumn / scroll));
                        // qDebug()() << horizontalBar->minimum() << " MAX " << horizontalBar->maximum() << "\n";
		}
		
		


    	}
	/*else
	{
		
	}*/
   
}

void ExerciseGui::scansion()
{
	

	scansionDialog->exec();
	scansionDialog->scansionInfo(scansionColor,scanOn,scanType,scansionGap,scansionMode);
	
	scanning = SCAN_EXPRESSION;

 	scansionGap *= 1000;
    	timer->stop();
	if(scanOn)
    	{
		pushButton0->show();
		pushButton1->show();
		pushButton2->show();
		pushButton3->show();
		pushButton4->show();
		pushButton5->show();
		pushButton6->show();
		pushButton7->show();
		pushButton8->show();
		pushButton9->show();
		pushButtonDel->show();
		pushButtonMinus->show();
		pushButtonOk->show();
		pushButtonSlash->show();
		pushButtonVerific->show();
		pushButtonDot->show();


		horizontalBar = tableWidget->horizontalScrollBar();
		
		if(scanType == 1) // scansione automatica
		{
			
			grabKeyboard();
			timer->start(scansionGap);	
			
		}
		else
			grabKeyboard();  // scansione manuale blocca tastiera	
		if(scansionMode == 1)
		{
			
			QBrush brushScansion(scansionColor, Qt::SolidPattern);
			(tableWidget->item(0,0))->setBackground(brushScansion);
			
			
		}
       		// ancora nn so sulla tabella
		tableWidget->setCurrentCell(0, 0);
       		 //pushButton_1->setFocus();
		
    	}
	else
	{
		pushButton0->hide();
		pushButton1->hide();
		pushButton2->hide();
		pushButton3->hide();
		pushButton4->hide();
		pushButton5->hide();
		pushButton6->hide();
		pushButton7->hide();
		pushButton8->hide();
		pushButton9->hide();
		pushButtonDel->hide();
		pushButtonMinus->hide();
		pushButtonOk->hide();
		pushButtonSlash->hide();
		pushButtonVerific->hide();
		pushButtonDot->hide();
		
		releaseKeyboard();

		if(scanType == 1)
			timer->stop();
		
		
	}		
	
	
}

void ExerciseGui::keyReleaseEvent( QKeyEvent *k )
{
  QFontMetrics metrics ( font );
  if ( done )
    return;
  // scanType = 1 auto

  // Added 21/8/2008
  // To  resize column
  tableWidget->setColumnWidth ( tableWidget->currentColumn(), ( metrics.width ( ( tableWidget->item ( 0, tableWidget->currentColumn() ) )->text() ) + 6 ) );

  // End Added

  if ( scanOn && scanType == 1 && !k->isAutoRepeat() )
  {

    /*
      if(scansionMode == 1)
      {
      }
      else
      {
      }
      */

    switch ( k->key() )
    {
      case Qt::Key_Space:
        if ( scanning == SCAN_EXPRESSION )
        {
          click ( tableWidget->currentItem() );
          /*if(boxError->isVisible())
           boxError->hide();*/
        }
        else
        {
          QPushButton *button = ( QPushButton * ) focusWidget();
          button->click();

          tableWidget->setColumnWidth ( tableWidget->currentColumn(), ( metrics.width ( ( tableWidget->item ( 0, tableWidget->currentColumn() ) )->text() ) + 6 ) );

        }
        break;
      default:
        QWidget::keyReleaseEvent(k);
        break;
    }
  }
}

void ExerciseGui::keyPressEvent( QKeyEvent *k )
{
  QFontMetrics metrics ( font );

  // scanType = 2 manual scansion
  if ( done )
    return;

  if ( !scanOn && !k->isAutoRepeat() )
  {

    if ( scanning != SCAN_EXPRESSION )
    {
      // qDebug()() << "PREMUTO" << "\n";
      switch ( k->key() )
      {

        case Qt::Key_1 :
          pushButton1->click();
          break;
        case Qt::Key_2 :
          pushButton2->click();
          break;
        case Qt::Key_3 :
          pushButton3->click();
          break;
        case Qt::Key_4 :
          pushButton4->click();
          break;
        case Qt::Key_5 :
          pushButton5->click();
          break;
        case Qt::Key_6 :
          pushButton6->click();
          break;
        case Qt::Key_7 :
          pushButton7->click();
          break;
        case Qt::Key_8 :
          pushButton8->click();
          break;
        case Qt::Key_9 :
          pushButton9->click();
          break;
        case Qt::Key_0 :
          pushButton0->click();
          break;
        case Qt::Key_Period :
          pushButtonDot->click();
          break;
        case Qt::Key_Backspace:
        {
          QString result = ( tableWidget->currentItem() )->text();

          if ( ! ( result.isEmpty() ) )
          {
            result.truncate ( result.length() - 1 );
            ( tableWidget->currentItem() )->setText ( result );
          }
          else /* select other operation, current will resolv after */
          {
            QFontMetrics metrics ( font );

            // Added 27/8/2008 to cell color
            if ( !scanOn )
            {
              QBrush brushBackground ( Qt::white, Qt::SolidPattern );
              ( tableWidget->item ( 0, tableWidget->currentColumn() ) )->setBackground ( brushBackground );
            }
            // End Added 27/8/2008 to cell color

            tableWidget->setColumnWidth ( ( tableWidget->currentItem() )->column(), metrics.width ( currentOperation ) + 6 );
            ( tableWidget->currentItem() )->setText ( currentOperation );
            /* Erase scansion color from selected item */
            tableWidget->setFocus();
            tableWidget->setCurrentCell ( 0, 0 );
            scanning = SCAN_EXPRESSION;
          }

        }
        //pushButtonDel->click();
        break;
        case Qt::Key_Slash:
          pushButtonSlash->click();
          break;
        case Qt::Key_Minus:
          pushButtonMinus->click();
          break;
        case Qt::Key_Return:
        {
          // qDebug()() << "PREMUTO RETURN\n";
          pushButtonVerific->click();
        }
        break;
        default:
          QWidget::keyPressEvent(k);
          break;
      }
    }
    else
    {
      switch ( k->key() )
      {
        case Qt::Key_Right:
        {
          int scroll;
          QScrollBar *horizontalBar = tableWidget->horizontalScrollBar();
          int currentColumn = tableWidget->currentColumn();

          currentColumn++;
          tableWidget->setCurrentCell ( 0, ( currentColumn = ( currentColumn % tableWidget->columnCount() ) ) );
          tableWidget->setCurrentItem ( tableWidget->item ( 0, currentColumn ) );
          tableWidget->scrollToItem ( tableWidget->currentItem(), QAbstractItemView::PositionAtCenter );

          if ( horizontalBar->isVisible() && ( tableWidget->columnCount() > horizontalBar->maximum() ) )
          {
            scroll = ( int ) ( tableWidget->columnCount() / horizontalBar->maximum() );

            horizontalBar->setSliderPosition ( ( int ) ( currentColumn / scroll ) );

          }
        }
        break;
        case Qt::Key_Return:
        {

          click ( tableWidget->currentItem() );
        }
        break;
        default:
          QWidget::keyPressEvent(k);
          break;
      }
    }

  }

  if ( scanOn && scanType == 2 && !k->isAutoRepeat() )
  {

    /*
           if(scansionMode == 1)
           {
           }
           else
           {
           }
           */

    switch ( k->key() )
    {
      case Qt::Key_Return :

        if ( scanning == SCAN_EXPRESSION )
          click ( tableWidget->currentItem() );
        else
        {
          QPushButton *button = ( QPushButton * ) focusWidget();
          button->click();
          tableWidget->setColumnWidth ( tableWidget->currentColumn(), ( metrics.width ( ( tableWidget->item ( 0, tableWidget->currentColumn() ) )->text() ) + 6 ) );

        }

        break;
      case Qt::Key_Space:
        if ( scanning == SCAN_EXPRESSION )
        {
          int scroll;
          QScrollBar *horizontalBar = tableWidget->horizontalScrollBar();
          int currentColumn = tableWidget->currentColumn();
          QBrush brushBackground ( Qt::white, Qt::SolidPattern );
          ( tableWidget->item ( 0, currentColumn ) )->setBackground ( brushBackground );
          QBrush brushScansion ( scansionColor, Qt::SolidPattern );
          ( tableWidget->item ( 0, currentColumn ) )->setBackground ( brushBackground );
          currentColumn++;
          tableWidget->setCurrentCell ( 0, ( currentColumn = ( currentColumn % tableWidget->columnCount() ) ) );
          tableWidget->setCurrentItem ( tableWidget->item ( 0, currentColumn ) );
          tableWidget->scrollToItem ( tableWidget->currentItem(), QAbstractItemView::PositionAtCenter );

          ( tableWidget->item ( 0, currentColumn ) )->setBackground ( brushScansion );

          if ( horizontalBar->isVisible() && ( tableWidget->columnCount() > horizontalBar->maximum() ) )
          {
            scroll = ( int ) ( tableWidget->columnCount() / horizontalBar->maximum() );

            horizontalBar->setSliderPosition ( ( int ) ( currentColumn / scroll ) );

          }
        }
        else
        {
          if ( pushButtonOk->hasFocus() )
            pushButton1->setFocus();
          else
            this->focusNextChild();
        }
        break;
      default:
        QWidget::keyPressEvent(k);
        break;
    }
  }
  else if ( scanOn && scanType == 1 && !k->isAutoRepeat() )
  {
    switch ( k->key() )
    {
      case Qt::Key_Space:
        if ( scanning == SCAN_EXPRESSION )
          timer->stop();
        break;
      default:
        QWidget::keyPressEvent(k);
        break;
    }
  }
}

void ExerciseGui::loadSetting()
{
    QSettings settings("Educazionik", APPL_NAME);
    if (settings.value("fontsize", 0).toInt() != 0) {

        scansionColor.setNamedColor(settings.value("scansioncolor").toString());
        backgroundColor.setNamedColor(settings.value("backgroundcolor").toString());
        buttonColor.setNamedColor(settings.value("buttoncolor").toString());
        textColor.setNamedColor(settings.value("textcolor").toString());
        font.setFamily(settings.value("fontfamily").toString());
        font.setPointSize(settings.value("fontsize").toInt());
    }
    else {

        scansionColor.setNamedColor("#ff0000");
        backgroundColor.setNamedColor("#d6cdbb");
        buttonColor.setNamedColor("#d6cdbb");
        textColor.setNamedColor("#000000");
        font = tableWidget->font();
    }

	setSetting();
}

void ExerciseGui::settingSave()
{
    QString fontSize;
    QSettings settings("Educazionik", APPL_NAME);


    fontSize.setNum(font.pointSize());


    settings.setValue("scansioncolor", scansionColor.name());
    settings.setValue("backgroundcolor", backgroundColor.name());
    settings.setValue("buttoncolor", buttonColor.name());
    settings.setValue("textcolor", textColor.name());
    settings.setValue("fontfamily", font.family() );
    settings.setValue("fontsize", fontSize );

}

void ExerciseGui::setSetting()
{
	QPalette palette;	
		
	/* Set font */
	
	textEdit->setFont(font);
	pushButton1->setFont( font );
	pushButton2->setFont( font );
	pushButton3->setFont( font );
	pushButton4->setFont( font );
	pushButton5->setFont( font );
	pushButton6->setFont( font );
	pushButton7->setFont( font );
	pushButton8->setFont( font );
	pushButton9->setFont( font );
	pushButton0->setFont( font );
	pushButtonDel->setFont( font );
	pushButtonOk->setFont( font );
	pushButtonVerific->setFont( font );

	pushButton1->adjustSize();
	pushButton2->adjustSize();
	pushButton3->adjustSize();
	pushButton4->adjustSize();
	pushButton5->adjustSize();
	pushButton6->adjustSize();
	pushButton7->adjustSize();
	pushButton8->adjustSize();
	pushButton9->adjustSize();
	pushButton0->adjustSize();
	pushButtonDel->adjustSize();
	pushButtonOk->adjustSize();
	pushButtonVerific->adjustSize();
	pushButtonSlash->adjustSize();
	pushButtonMinus->adjustSize();		

	label->setFont(font);
	label_2->setFont(font);
	label->adjustSize();
	label_2->adjustSize();



	/* Set Text color */
	
        // qDebug()() << textColor.name() << endl;
	
	palette.setColor(QPalette::WindowText, textColor);
	setPalette(palette);
	
	palette.setColor(QPalette::ButtonText, textColor);
	pushButton1->setPalette( palette );
	pushButton2->setPalette( palette );
	pushButton3->setPalette( palette );
	pushButton4->setPalette( palette );
	pushButton5->setPalette( palette );
	pushButton6->setPalette( palette );
	pushButton7->setPalette( palette );
	pushButton8->setPalette( palette );
	pushButton9->setPalette( palette );
	pushButton0->setPalette( palette );
	pushButtonDel->setPalette( palette );
	pushButtonOk->setPalette( palette );
	pushButtonVerific->setPalette( palette );

	palette.setColor(QPalette::Text, textColor);
	tableWidget->setPalette(palette);
	textEdit->setPalette(palette);
	
	/* Set Button Color */
	
	palette.setColor(QPalette::Button, buttonColor);
	pushButton1->setPalette( palette );
	pushButton2->setPalette( palette );
	pushButton3->setPalette( palette );
	pushButton4->setPalette( palette );
	pushButton5->setPalette( palette );
	pushButton6->setPalette( palette );
	pushButton7->setPalette( palette );
	pushButton8->setPalette( palette );
	pushButton9->setPalette( palette );
	pushButton0->setPalette( palette );
	pushButtonDel->setPalette( palette );
	pushButtonOk->setPalette( palette );
	pushButtonVerific->setPalette( palette );
	pushButtonSlash->setPalette( palette );
	pushButtonMinus->setPalette( palette );
	
	/* Set background color */
	
        // qDebug()() << backgroundColor.name();
	
	palette.setColor(QPalette::Window, backgroundColor);
	setPalette(palette);
	
}

void ExerciseGui::info()
{  
  QString title     = QString(APPL_NAME) + " V. " + QString(APPL_VERSION);
  QString info = "(c) 2009 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                 "(c) 2010 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi per il calcolo di espressioni";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";

  //AboutDialog about(this, title, info, description, icon);
  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

void ExerciseGui::resetScore()
{
//	lcdScore->display(0);

	score->setText("0");
	labelNError->setText("0");
}

void ExerciseGui::manual()
{
  QTextBrowser *manual;
  QUrl fileManual;

//#if defined(Q_OS_WIN)
//  fileManual.setUrl ( QUrl::fromLocalFile ( QString ( DOC_DIR ) + "/manuals/manualeEspressioni.htm" ).toString() );
//  //QUrl fileManual(QDir::currentPath() + "/" + "manualeEspressioni.htm");
//#else

  if ( QLocale::system().name() != "it_IT" )
  {
    fileManual.setUrl ( QUrl::fromLocalFile ( QString ( DOC_DIR ) + "/manuals/manualExpik.htm" ).toString() );
  }
  else
    fileManual.setUrl ( QUrl::fromLocalFile ( QString ( DOC_DIR ) + "/manuals/manualeEspressioni.htm" ).toString() );

//#endif

  manual = new QTextBrowser();
  manual->setSource ( fileManual );
  manual->setGeometry ( 30,150,800,800 );
  manual->show();
}
