/***************************************************************************
 *   Copyright (C) 2006 by Nicola De Filippo   *
 *   nicola@nicoladefilippo.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include "operation.h"

Operation::Operation()
{
	operation.resize(7);
	operation[0].setOperation('(');
	operation[0].setPriority(0);
	operation[1].setOperation(')');
	operation[1].setPriority(0);
	operation[2].setOperation('+');
	operation[2].setPriority(1);
	operation[3].setOperation('-');
	operation[3].setPriority(1);
	operation[4].setOperation('*');
	operation[4].setPriority(2);
	operation[5].setOperation(':');
	operation[5].setPriority(2);
	operation[6].setOperation('^');
	operation[6].setPriority(3);

}


bool Operation::isSimbol(char s)
{
	Simbol dum;
	vector<Simbol>::iterator i = operation.begin();
	dum.setOperation(s);
	
	while(i != operation.end())
	{
		if(dum == *i)
			return true;
		i++;
	}
	return false;
}

int Operation::priority(char s)
{
	if(isSimbol(s))
	{
		Simbol dum;
		vector<Simbol>::iterator i = operation.begin();
		dum.setOperation(s);
		
		while(i != operation.end())
		{
			if(dum == *i)
				return (*i).priority();
			i++;
		}
		return -1;
	}
	return -1;
}
	
bool Operation::isOperation(char s)
{
	Simbol dum;
	vector<Simbol>::iterator i = operation.begin();
	dum.setOperation(s);
	
	while(i != operation.end())
	{
		if(dum == *i && (*i).priority() > 0)
			return true;
		i++;
	}
	return false;
}

