#include "z.h"
#include <iostream>
#include <sstream>
#include <math.h>

using namespace std;


Z::Z(double n, double d)
{
	numerator = n; 
	if(denominator != 0)
		denominator = d;
	else
		denominator = 1;
		
	oldValue = numerator / denominator;
	setMaxString(n, denominator);
	//semplific();
}

bool Z::operator == (Z a)
{ 
	double second = (double) a.numerator / (double) a.denominator;
	double first = (double) this->numerator / (double) this->denominator;

        //cout << "this->numerator " << this->numerator << " this->denominator " << this->denominator <<"/n";
        //cout << "first " << first << " second " << second << "\n";

	return (first == second);
}



bool Z::operator <= (Z a)
{ 
	double second = (double) a.numerator / (double) a.denominator;
	double first = (double) this->numerator / (double) this->denominator;

	return (first <= second);
}

bool Z::operator < (Z a)
{ 
	double second = (double) a.numerator / (double) a.denominator;
	double first = (double) this->numerator / (double) this->denominator;

	return (first < second);
}

bool Z::operator < (double a )
{
	return (((double) this->numerator / (double) this->denominator) < ((double) a));
}

bool Z::operator > (double a )
{
	return (((double) this->numerator / (double) this->denominator) > ((double) a));
}

bool Z::operator <= (double a )
{
	return (((double) this->numerator / (double) this->denominator) <= ((double) a));
}

bool Z::operator >= (double a )
{
	return (((double) this->numerator / (double) this->denominator) >= ((double) a));
}

bool Z::operator >= (Z a)
{ 
	double second = (double) a.numerator / (double) a.denominator;
	double first = (double) this->numerator / (double) this->denominator;

	return (first >= second);
}


bool Z::operator > (Z a)
{ 
	double second = (double) a.numerator / (double) a.denominator;
	double first = (double) this->numerator / (double) this->denominator;

	return (first >= second);
}

Z& Z::operator = (Z a)
{
	oldValue = numerator / denominator;
	numerator = a.numerator;
	denominator = a.denominator;
	setMaxString(numerator, denominator);
	return *this;
}


Z& Z::operator += (Z a)
{
	double mcmDenominators = mcm(denominator, a.denominator);
	
	oldValue = numerator / denominator;
	
	numerator = (mcmDenominators * numerator) / denominator + 
			(mcmDenominators * a.numerator) / a.denominator;
	denominator = mcmDenominators;
	setMaxString(numerator, denominator);
	semplific();
	return *this;
}

Z operator + (Z a, Z b)
{
	Z r = a;
	return r += b;	
}



Z& Z::operator -= (Z a)
{
	double mcmDenominators = mcm(denominator, a.denominator);
	numerator = (mcmDenominators * numerator) / denominator -
			(mcmDenominators * a.numerator) / a.denominator;
	
	denominator = mcmDenominators;
	setMaxString(numerator, denominator);
	semplific();
	return *this;
}

Z operator - (Z a, Z b)
{
	Z r = a;
	return r -= b;	
}

Z operator - (double a, Z b)
{
	Z r(a, 1);
	return r -= b;	
}

Z& Z::operator *= (Z a)
{
	numerator = numerator * a.numerator;
	denominator = denominator * a.denominator;
	setMaxString(numerator, denominator);
	semplific();
	return *this;
}

Z operator * (Z a, Z b)
{
	Z r = a;
	return r *= b;	
}

Z& Z::operator /= (Z a)
{
	numerator = numerator * a.denominator;
	denominator = denominator * a.numerator;
	setMaxString(numerator, denominator);
	semplific();
	return *this;
}

Z operator / (Z a, Z b)
{
	Z r = a;
	return r /= b;	
}


double Z::mcd(double m, double n)
{
		
        if(m == n)
                return m;
        else if(m == 0)
        	return n;
        else if(n == 0)
        	return m;
        else if(m == 0 && n == m)
        	return 1;
        else if(m == 1 || n == 1)
        	return 1;
        else if(m > n)
                return mcd(n,(int) m % (int)n);
        else
                return mcd(m,(int) n % (int)m);
}

double Z::mcm(double m, double n)
{
        return ((m * n)/mcd(m ,n));
}

string Z::toString()
{
	string text;
	ostringstream streamNumerator;	
	streamNumerator << numerator;
	text += streamNumerator.str();
	
	
	if(denominator != 1)
	{
		ostringstream streamDenominator;
		streamDenominator << denominator;
		text += "/" + streamDenominator.str();
	}
	return text;	
}

void Z::setMaxString(double num, double den)
{
	string text;
	ostringstream streamNumerator;	
	
        //cout << "OLD " << oldValue << "NEW " << num << " " << den << "\n";
	
	if(oldValue != (num / den))
	{
		
	
	
		streamNumerator << num;
		text += streamNumerator.str();
		
		
		
		if(denominator != 1)
		{
			ostringstream streamDenominator;
			streamDenominator << den;
			text += "/" + streamDenominator.str();
		}
		maxString = text;
                //cout << "++ SETMAXSTRING ++ maxString " << maxString << "\n";
		oldValue = num / den;
	}
}



void Z::semplific()
{
	double mcdND = mcd(fabs(numerator), fabs(denominator));

	while(mcdND != 1)
	{
		numerator = numerator / mcdND;
		denominator = denominator / mcdND;
		mcdND = mcd(fabs(numerator), fabs(denominator));
	}

	/* one minus */
	
	if(denominator < 0)
	{
		numerator = 0 - numerator;
		denominator = 0 - denominator;
	}

}


bool Z::isSimple()
{
	if(mcd(fabs(numerator), fabs(denominator)) == 1)
		return true;
	return false;
		
}

/*
int main()
{
	Z a(11,5), b(10,4);
	Z z;
	

        //cout << "A = " << a.toString() << " B = " << b.toString() << "\n";
	z = a + b;
        //cout << "A + B = " << z.toString() << "\n";
	
	//z.set(0,1);
	z = a - b;
        //cout << "A - B = " << z.toString() << "\n";

	z = a * b;
        //cout << "A * B = " << z.toString() << "\n";

	z = a / b;
        //cout << "A : B = " << z.toString() << "\n";

        //cout << "A = " << a.toString() << " B = " << b.toString() << "\n";

	if(b >= a)
                //cout << "minore\n";
	else
                //cout << "Errore \n";
	
	

	return 0;
}
*/
