/* ============================================================
 *
 * This file is a part of educazionik project
 * http://educazionik.sourceforge.net/
 *
 * Date        : 4/6/2003
 * Description : Uso H implementation
 *
 * Copyright 2003-2009 by Nicola De Filippo <nicola@nicoladefilippo.it>
 * Copyright 2009      by Angelo Naselli    <anaselli at linux dot it>
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include "dialogmain.h"
#include "ui_dialogmain.h"
#include <QMessageBox>
#include <QString>
#include "aboutdlg.h"
#include "usoh_version.h"

DialogMain::DialogMain(QWidget *parent)
        : QDialog(parent), ui(new Ui::DialogMain)
{
    ui->setupUi(this);
    QString title = QString(APPL_NAME)    + " V. " +
                    QString(APPL_VERSION);
    setWindowTitle(title);

    setWindowIcon(QIcon( QPixmap(QString(RESOURCE_DIR) + "/educazionik.png")));
}


void DialogMain::a_ha()
{
    play.game("a ha", ui->RadioButton2->isChecked());
}

void DialogMain::o_ho()
{
    play.game("o ho", ui->RadioButton2->isChecked());
}

void DialogMain::ai_hai()
{
    play.game("ai hai", ui->RadioButton2->isChecked());
}

void DialogMain::anno_hanno()
{
    play.game("anno hanno", ui->RadioButton2->isChecked());
}

void DialogMain::info()
{
  QString title = QString(APPL_NAME)    + " V. " +
                  QString(APPL_VERSION) + " "    +
                  QString(APPL_DATE)    + " "    +
                  QString(APPL_TIME);
  QString info = "(c) 2003 <b>Nicola De Filippo</b> - nicola@nicoladefilippo.it<br>"
                    "(c) 2009 <b>Angelo Naselli</b>    - anaselli@linux.it<br>";
  info += "http://educazionik.sourceforge.net";
  QString description = "Programma di esercizi per l'uso della H";
  QString icon = QString(RESOURCE_DIR) + "/logo.png";
  
  //AboutDialog about(this, title, info, description, icon);
  AboutDialog about(this, title, "", description, icon, "", "", "");
  about.exec();
}

DialogMain::~DialogMain()
{
    delete ui;
}
